
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that there is a use for it.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		basc;
	id		baux;
	id		gridSize;
	id		wrule;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		sRuleCoef;
	id		sRuleExp1;
	id		sRuleExp2;
	id		sRuleIncr;
	id		statEnpai;
	id		statEntro;
	id		statLines;
	id		statMode;
	id		statPair;
	id		statState;
	id		statSDevi;
	id		statNhood;
	id		statIndx;
	id		statLamb;
	id		tiDat;
	id		valBx;

	id		theEntropyView;
	id		theEvolView;
	id		thePlaidView;
	id		theShEvolView;
	id		theThEvolView;

	id		entropyWindow;
	id		evolWindow;
	id		keyWindow;
	id		plaidWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	
	id		keepTop;
	id		aSwitch;
	id		pswit;

	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		crossCursor;
}

- drawEvolu:sender;
- drawShEvol:sender;
- copyShEvol:sender;
- drawThEvol:sender;
- copyThEvol:sender;
- drawEntropy:sender;

- nxasfreq;
- nxmoncar: (int) l;
- printEvolu:sender;
- printLCAU:sender;
- symRule:sender;
- prob:sender;
- makeline:sender;

- copyEntropy:sender;
- copyPlaid:sender;
- copyStat:sender;

- drawPlaid:sender;
- drawStat:sender;

- printPlaid:sender;
- printEntropy:sender;

- printStat:sender;
- printShEvol:sender;
- printThEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;

@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end

/* end LCAUView.h */
