
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example. 
 * NeXT disclaims any warranty of any kind, expressed or implied, as to  
 * its fitness for any particular use, nor even that it has a use. 
 *
 */

#import "LCAUView.h"
#import "nxlcau4h.h"
#import "nxardn4h.h"
#import "nxprob4h.h"
#import "drawingFuncs.h"
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <math.h> 
#import <stdlib.h>
#import <string.h>

extern char trule[TS];
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];

extern int  binrule[KK][KK];

extern char colorwells[KK][6];

int    drawArhi=NO;
int    drawBack=YES;
int    drawEntpy=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawMonc=NO;
int    drawShort=NO;
int    drawThird=NO;
int    drawTMatrix=NO;
int    showStat=NO;
int    drawPlaid=NO;
int    drawview=0;
int    plaidline[2];

int    ardnl, ardnll;
int    srule[2][27];
int    cu=12;

extern NXColor colst[KK];

double cubic[25][25][25];

extern double stt, sta[5][K3+1];

extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];

void	asctobin();
void	confr(int vv);
void	conth(double z[25][25][25], double c, int i, int j, int k, int vv);
void	cudem(double f[25][25][25], int l, int m, int n, int v);
void	edshf(int g, int s, int i);
void	evolve();
int	nearest(double x, double y);
void	onegen(int n);
void	penry(int n);
void	pprob();
void	ranlin();
void	ranrul();
void	renewarry();
void	savearry();
void	serms(double x, double y, int l, int m);
void	shortevolve(int m, int n);
double	tdist(int i, int j, int n);
void	totoasc();
void	wru(char *c);

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {

  NXSetColor(colst[l]);

  switch (drawview) {
case 0: PSrectfill((float)((2*AL+2*j-i)%(2*AL)),2.0*(float)i,1.25,1.25); break;
case 1: PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
case 6: PSrectfill(2.5*(float)j,2.5*(float)i,9.0,9.0); break;
case 7: PSrectfill((float)j,(float)i,3.125,3.125); break;    
default: break;}
      
}

/* m = line length; n = number of lines    */
/* version for use with half-integer radii */
void shortevolve(m,n) int m, n; {
int i, j, k, l, o;
savearry();    
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
      k=j%2; l=j/2;
    for (i=0; i<m; i++) videodot(4*j,4*i-2*k,arr1[(AL+i+o+l)%AL]);
    onegen(AL);
    }
  renewarry();
}


/* --------------------------- E V O L U T I O N --------------------------- */

- drawShEvol:sender {
    drawview=7;
    drawShort=YES;
    [theShEvolView display];
    drawShort=NO;
return self;
}

- printShEvol:sender {
    drawview=7;
    drawShort=YES;
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- printLCAU:sender {
    if (keyWindow==evolWindow)   [self printEvolu:  sender];
    if (keyWindow==shEvolWindow) [self printShEvol: sender];
    if (keyWindow==thEvolWindow) [self printThEvol: sender];
    if (keyWindow==plaidWindow)  [self printPlaid:  sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyThEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=6;
  drawThird=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theThEvolView getBounds: &zbounds];
  [theThEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawThird=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=0;
  drawEvol=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theEvolView getBounds: &zbounds];
  [theEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawEvol=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==evolWindow)   [self copyEvolu:  sender];
    if (keyWindow==shEvolWindow) [self copyShEvol: sender];
    if (keyWindow==thEvolWindow) [self copyThEvol: sender];
    if (keyWindow==plaidWindow)  [self copyPlaid:  sender];
return self;
}

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [keyWindow smartPrintPSCode: self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

- printPlaid:sender {
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [keyWindow smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];
return self;
}

double tdist(i,j,n) int i, j, n;
{ int a[10], b[10], l, m; double kay, s, t, u;
  if (n>10) return 0.0;
  kay=1.0/((double)KK);
  for (l=0; l<n; l++) a[l]=b[l]=0;
  for (m=i, l=0; l<n; m/=KK, l++) a[n-l-1]=m%KK;
  for (m=j, l=0; l<n; m/=KK, l++) b[n-l-1]=m%KK;
  for (s=0.0, t=1.0, l=0; l<n; t*=kay, l++)
     { u=a[l]-b[l]; s+=t*((u<0.0)?-u:u);}
  return s*kay;
}

void penry(n) int n;
{ int i, j, lnco();
  double a[KK], t, em, en;
  if (n==0) return;
  em=1.0/log(3.0);
  en=1.0/((double)(n));
  for (i=0; i<=n; i++){
	for (j=0; i+j<=n; j++){
		t=0.0;
		a[0]=((double)(i))*en; if (a[0]>0.005) t+=a[0]*log(a[0]);
		a[1]=((double)(j))*en; if (a[1]>0.005) t+=a[1]*log(a[1]);
		a[2]=1.0-a[0]-a[1]; if (a[2]>0.005) t+=a[2]*log(a[2]);
		videotrdot(a,lnco(-t*em,i));
		}}
}


/* -------------------------------- L C A U -------------------------------- */


/* -------------------------------- A R D N -------------------------------- */


/* -------------------------------- R I J N -------------------------------- */


/* -------------------------------- P R O B -------------------------------- */

- drawStat:sender {
 drawview=5;
    showStat=YES;
    [self display];
    showStat=NO;
return self;
}

- printStat:sender {
   drawview=5;
   showStat=YES;
   [keyWindow smartPrintPSCode:self];
   showStat=NO;
return self;
}

- nxmoncar: (int) l {
int i, j, k, n, b[KK], bb[KK][KK];
double bf[KK], bbf[KK][KK];
double a[KK], aa[KK], d[KK], el, en, t, tt, s;

// nblclr();
n=[[statLines selectedCell] tag];
asctobin();
el=1.0/((double)AL);
en=1.0/((double)n);
for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
for (k=0; k<n; k++) {
  onegen(AL);
  for (i=0; i<KK; i++) b[i]=0;
  for (i=0; i<AL; i++) b[arr1[i]]++;
  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
  for (i=1; i<AL; i++) bb[arr1[i-1]][arr1[i]]++;
  bb[arr1[AL-1]][arr1[0]]++; 
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
    bbf[i][j]=((double)(bb[i][j]))*el;
//  videodot(199-(int)(100.0*bbf[1][1]),BORG+(int)(100.0*bf[1]),l);
  }
for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
s=1.0/log((double)KK);
t=0.0; tt=0.0;
for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
  [statLamb setDoubleValue: 1.0-bf[0]];
  [statEntro setDoubleValue: -t*s];
  [statEnpai setDoubleValue: -0.5*tt*s];
 printf("average      = %5.3f, %5.3f, %5.3f\n",a[0],a[1],a[2]);
 printf("deviation    = %5.3f, %5.3f, %5.3f\n",d[0],d[1],d[2]);
	[statSDevi setDoubleValue: (d[0]+d[1]+d[2])/3.0];
  for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: bf[i]];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	[[statPair cellAt: 0: i*KK+j] setDoubleValue: bbf[i][j]];
return self;
}

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq  {
int    i, j, i0, i1;
int    stat[KK], stal, stac, star;		/* statistic counts */
double staf[KK], t, pp;

pp=1.0/((double)(KK*KK));
stal=0; stac=0; star=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  j=ascrule[i0][i1]-'0';
  stat[j]++;
  if(j==i0) stal++;
  if(j==i1) star++;
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
// for (i=0; i<KK; i++) printf("%d freq - %5.2f\n",i,staf[i]);
	[statIndx setDoubleValue: ((double)stal)*pp at: 0];
	[statIndx setDoubleValue: ((double)star)*pp at: 1];
// j=199-(int)(100.0*staf[1]);
// i=CORG+(int)(100.0*staf[1]);
// if (j>=2) videodot(j-2,i,l);
// if (i>=2) videodot(j,i-2,l);
// videodot(j,i,1);
// if (i<=318) videodot(j,i+2,l);
// if (j<=198) videodot(j+2,i,l);
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
return self;
}

- drawEntropy:sender
{ drawview=9;
  drawEntpy=YES;
  [self display];
  drawEntpy=NO;
  return self;
}

- printEntropy
{ drawview=9;
  drawEntpy=YES;
  [self display];
  [keyWindow smartPrintPSCode: self];
  drawEntpy=NO;
  return self;
}
  

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - L C A U V i e w - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = 
		[NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

//    videocursor(0,0,0);
//    PSshow("...LCAU21..."); 

  [self setFlipped: YES];

	return self;

}

- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	unsigned int	 i, j, k, l, n;
	int		 ii, jj, nn, bas;
        double           en, p, q, r, s, t, dp, pee, cue;
	double		 aa[KK], bb[KK], cc[KK], cq[KK];
	double		 bern(), dbern(), tbern(), fbern();
	NXPoint		 *aPoint;
	NXRect		 plotRect;
        struct tm  *timeptr;
        time_t  secsnow;

	int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);


        if (drawEvol==YES) {
	wru(c);
        [ruleNumber setStringValue: c];
		if ([keepTop state]) savearry();
	  	evolve();
		if ([keepTop state]) renewarry();
	  }

        if (drawShort==YES) {
          wru(c);
          [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

         if (drawThird==YES) {
  	   [self getBounds:&plotRect];
	   i=(int)(plotRect.size.width/10.0);
	   j=(int)(plotRect.size.height/10.0);
	   shortevolve(i,j);
	   }

	if (drawPlaid==YES) {		/* one cycle of evolution */
		n=[[gridSize selectedCell] tag];
		if (strcmp([[aSwitch selectedCell] title],"distance")==0)
		   { [ruleNumber setStringValue: "distance matrix"];
		     for (i=0; i<256; i++) for (j=0; j<256; j++)
			 { r=tdist(i,j,5);
			  PSsetcmykcolor(0.1*r,0.8*r,1.0-r,0.55*r);
			  PSrectfill((float)(j),(float)(i),1.0,1.0);
 			}
		PSstroke();
		   }
	if (strcmp([[aSwitch selectedCell] title],"circles")==0)
		{ sprintf(c,"center: %3d, %3d\n", plaidline[0],plaidline[1]);
		  [ruleNumber setStringValue: c];
		     for (i=0; i<256; i++) for (j=0; j<256; j++)
			{ p=tdist(i,plaidline[1],5);
			  q=tdist(i,plaidline[0],5);
			  s=(p+q);
			  PSsetcmykcolor(s,0.05*p,1.0-s,0.05*q);
			  PSrectfill((float)(j),(float)(i),1.0,1.0);
			}
		  PSstroke();
		  PSsetgray(NX_BLACK);
		  PSrectfill((float)(plaidline[0]),(float)(plaidline[1]),2.0,2.0);
		  PSstroke();
		}
	if (strcmp([[aSwitch selectedCell] title],"plaid")==0)
		{ wru(c);
		  [ruleNumber setStringValue: c];
		  savearry();
		  asctobin();
		  for (j=0; j<128; j++)
			{ ranlin();
			  for (i=0; i<64; i++){ onegen(AL); pprob();}
			}
		  renewarry();
		}
	if (n>0)
		{ PSsetgray(NX_BLACK); 
		  PSsetlinewidth(0.0);
		    for (j=1, dp=256.0, i=0; i<n; i++) {j*=4; dp*=0.25;}
		    for (i=0, p=1.0; i<j+1; i++, p+=dp)
			{ PSmoveto(0.1,p);
			  PSlineto(256.0,p);
			  PSmoveto(p,0.1);
			  PSlineto(p,256.0);
			}
		    PSstroke();
		}
	}

	if (drawEntpy==YES) {
		penry(100);
		PSsetlinewidth(0.05);
		PSsetgray(NX_BLACK);
		linegrid(10);
		PSstroke();
		PSsetlinewidth(0.0);
	   }

	if (showStat==YES) {
          wru(c);
          [ruleNumber setStringValue: c];
	    if (strcmp([[statNhood selectedCell] title],"totalistic")==0) {
		[self nxmoncar: 2];
		neisum(0,AL,48);
                }
	    if (strcmp([[statNhood selectedCell] title],"general")==0) {
		[self nxmoncar: 2];
		gnlsum(0,AL,48);
                }
	    }
	  

        if (drawArhi==YES) {
      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
      stt=0.0;
      allmo(&stt,sta);
      ss=1;
		}

	if (drawTMatrix==YES) {
//	qqmat(umat,0,0);
	}

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

	return self;
}


- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin: 0 :0]; return self;}
	else [self setDrawOrigin: -floor(width/2): -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect;

         double   ex, wy;     //, eks, wye;x, y,
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {looping = NO;}	
   	} while (looping && 
	(theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

@end

/* end LCAUView.m */
