
#import "RulePanel.h"
#import "nxlcau4h.h"
#import "rec.h"
#import <string.h>
#import <math.h>
#import <time.h>

extern char arr1[], arr2[];
extern char ascrule[KK][KK];
extern char auxrule[KK][KK];
extern char gf4rule[13];		  /* coefficients of gf4 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK][SS];
extern char sarule[KK][SS];

extern char   prule1[8], prule2[8];	   /* product rule specification */
extern char   evrule[2][2][2][2];	   /* evolutionary rule */
extern char   bhrul1[2][2], bhrul2[2][3];  /* binary r=1/2 rule #1,2 */



extern birular binrule;

extern struct fptbl dtbl [] ; 
extern Inst xprg [10][XLEN];
extern char idef [][30];

int permu[RSYM/2][KK] = {
	{0, 1, 2, 3},
	{1, 2, 3, 0},
	{2, 3, 0, 1},
	{3, 0, 1, 2},

	{1, 2, 0, 3},
	{2, 3, 1, 0},
	{3, 0, 2, 1},
	{0, 1, 3, 2},

	{2, 0, 1, 3},
	{3, 1, 2, 0},
	{0, 2, 3, 1},
	{1, 3, 0, 2},


	{1, 0, 2, 3},
	{2, 1, 3, 0},
	{3, 2, 0, 1},
	{0, 3, 1, 2},

	{2, 1, 0, 3},
	{3, 2, 1, 0},
	{0, 3, 2, 1},
	{1, 0, 3, 2},

	{0, 2, 1, 3},
	{1, 3, 2, 0},
	{2, 0, 3, 1},
	{3, 1, 0, 2}
	};


/* .............................................*/

int     allperm(char wnum[][WNML], char ii[][KK][KK], char ru[KK][KK]);
void    asctobin();
void	asczero();
void	auxzero();
void    bincopy(birular *rz, birular *rx); 
void    binprint(birular *rz);
void    binprod(birular *rz, birular *rx, birular *ry);  
void    binsum(birular *rz, birular *rx, birular *ry);
void    bintoasc();
void    chrucopy(char ii[KK][KK], char jj[KK][KK], int c);
void    clumin(char *c);
int     cyy(int i);
int     czz(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
int     longwolftoasc(char *c);
void    nutowo1(int i);
void    nutowo2(int i);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of4(int a, int b);
int     ran3of4(int a, int b, int c);
void    ranrul();
void    ranblin(double p0, double p1, double p2, double p3);
void    ranvachrul(char *c);
void    rule4h();
void    runowows(char x[2][2], int n);
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
int     vecperm(int ii[KK], int n);
int     wolbin(int i, int j);
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK]);
void    wthru(char *c, char ru[KK][KK][KK][KK]);
void	xtoasc(int n);
int     ycc(int i);
int     zcc(int i);

char    xr[] = "121220101221200000101000100";
char    xp[] = "532337242335361411252611214";
char    xq[] = "1359326A564C9AC8";

char dsgnrule[KK][KK];

//  {"path" "/seagate/McIntosh/Sealcau/3/nxlcau4H"},


@implementation RulePanel


/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"Arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"Equivalence")==0) [self loadLowerPanel: equivRuleBox];
  if (strcmp(ch,"Permuted")==0)    [self loadLowerPanel: permutRuleBox];
  if (strcmp(ch,"Product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"Clannish")==0)    [self loadLowerPanel: subsetRuleBox];
  if (strcmp(ch,"Reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {
NXRect bxRect, loRect;
id     cv;
  nowSpesh=thisRuleBox;
  cv=[thisRuleBox contentView];
printf("thisRuleBox count = %d\n",[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow)  nowBox=ruleBox;
  if (sender==speshPanel)  nowBox=nowSpesh;
  if (sender==infoPanel)   nowBox=sender;
  if (sender==designPanel) nowBox=designBox;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- protectGenRule:sender {int i, j, k, i0, i1;
//     printf("hello from protectGenRule \n");
i=j=[sender selectedCol];
       i1=i%KK; i/=KK;
       i0=i%KK; i/=KK;
  k=auxrule[i0][i1];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1]=!k;			/* auxrule = a la neg de k */
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"4-cycle")==0)   k= 1;
  else if (strcmp(titl,"3-cycle")==0)   k= 4;
  else if (strcmp(titl,"2-cycle")==0)   k=12;
  else if (strcmp(titl,"reflect")==0)   k=24;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"least")==0)     k= l;
  else    			        k= 0;
  if (k==RSYM) {
    clumin(c);
    longwolftoasc(c);
    [self setAllRules: self];
    [self setAllImages: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
    [self setAllRules: self];
    [self setAllImages: self];
  if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n;
{int i, k, l;
  l=!(n<RSYM/2); k=(l?n-RSYM/2:n);
  for (i=0; i<KK; i++) ii[i]=permu[k][i];
  return l;
}

/* generate a table of permutations of a given rule       */
/* and report the index of the rule with smallest wru     */
/* wn - array to be filled with 9-letter wolfram numbers  */
/* ii - array to be filled with ascrule symmetry images   */
/* ru - reference KK8KK8KK table - e.g. ascrule           */
/* return value is the index of the least of all these    */
/* that is, wn[...] is the number, ii[...] is the rule    */

int allperm(wn,ii,ru) 
  char wn[][WNML], ii[][KK][KK], ru[KK][KK]; {int i, l, k;
chrucopy(ii[0],ru,'w');					        /* identity */
for (i=1; i<KK; i++) chrucopy(ii[i],ii[i-1],'y'); 	        /* 4-cycles */
for (i=KK; i<2*KK; i++) chrucopy(ii[i],ii[i-KK],'z');	        /* 3-cycles */
for (i=2*KK; i<3*KK; i++) chrucopy(ii[i],ii[i-KK],'z'); 	/* 3-cycles */
for (i=RSYM/4; i<RSYM/2; i++) chrucopy(ii[i],ii[i-RSYM/4],'t'); /* 2-cycles */
for (i=RSYM/2; i<RSYM; i++) chrucopy(ii[i],ii[i-RSYM/2],'r');   /* reflect  */
for (k=0, l=0; k<RSYM; k++) {
    wrru(wn[k],ii[k]);
    if (strlen(wn[k]) > strlen(wn[l])) continue;
    if (strlen(wn[k]) < strlen(wn[l])) {l=k; continue;}
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
return l;
}

/* copy a related (character) rule */
/* c = w - no change  		   */
/* c = y - 4-cyclic permutation    */
/* c = z - 3-cyclic permutation    */
/* c = t - 2-cyclic permutation	   */
/* c = r - reflected neighborhood  */

void chrucopy(ii,jj,c) char ii[KK][KK], jj[KK][KK],  c; {
int i0, i1;
  switch (c) {
    case 'w':					/* simple copy = identity */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=jj[i0][i1];
      break;
    case 'y':					/* 4-cycle */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=ycc(jj[cyy(i0)][cyy(i1)]);
      break;
    case 'z':					/* 3-cycle */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=zcc(jj[czz(i0)][czz(i1)]);
      break;
    case 'r':					/* reflected neighborhood */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=jj[i1][i0];
      break;
    case 't':					/*   transposicion     */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
        ii[i0][i1]=fli(jj[fli(i0)][fli(i1)]);
      break;
    default: break;}
}

int fli(i) int i; {
  switch (i) {
	case '0': return '1';			/*   ascci  */
	case '1': return '0'; 
	case '2': return '2';
	case '3': return '3';
	case 0: return 1;			/*    binary */
	case 1: return 0; 
	case 2: return 2;
	case 3: return 3;
	default:  return '0';}
}

int cyy(i) int i; {
  switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
	case '3': return '0';

	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
	case 3: return 0;

	default:  return '0';}
}

int ycc(i) int i; {
  switch (i) {
	case '0': return '3';
	case '1': return '0'; 
	case '2': return '1';
	case '3': return '2';

	case 0: return 3;
	case 1: return 0; 
	case 2: return 1;
	case 3: return 2;

	default:  return '0';}
}

int czz(i) int i; {
  switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '0';
	case '3': return '3';

	case 0: return 1;
	case 1: return 2; 
	case 2: return 0;
	case 3: return 3;

	default:  return '0';}
}

int zcc(i) int i; {
  switch (i) {
	case '0': return '2';
	case '1': return '0'; 
	case '2': return '1';
	case '3': return '3';

	case 0: return 2;
	case 1: return 0; 
	case 2: return 1;
	case 3: return 3;

	default:  return '0';}
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {return self;}

-readWRule:sender {char *c; int l;
  c=[sender stringValue];
  l=strlen(c);
  if (l>=WNML) {[ruleNumber setStringValue: "exceeded "]; return self;}
  if      (longwolftoasc(c)) 
	  {[self setAllRules: self]; [self setAllImages: self];}
     else [ruleNumber setStringValue: "invalid"];
return self;
}

int longwolftoasc (char *c) {
char d[WNML], e;
int i, l, n, i0, i1;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'f') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'F') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i=0; i<WNML-1; i++) {
    n=d[WNML-2-i];
    i0=i/2;
    i1=(2*i)%KK;
    ascrule[i0][i1]=  '0'+n%KK;  
    ascrule[i0][i1+1]='0'+n/KK;
    }
  return TRUE;
}

- readSqRule:sender {char ch[WNML]; int i, j;
   for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
	ascrule[i][j] = [[sender cellAt: i: j] intValue] + '0';
   [self setAllRules: self];
   [self setAllImages: self];
   return self;
}

- setRule:sender {char ch[WNML]; int i, ii, j, jj, i0, i1;
   wru(ch);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  [self setAllImages: self];

  return self;
}

- insertRule:sender {
char c[2];
int  i, j, k;
  i=[sender selectedRow];
  j=[sender selectedCol];
  k=[whichState selectedRow]+'0';
  ascrule[i][j]=k;
  c[0]=k; c[1]=0;
  [[sender selectedCell] setTitle: c];
  [self setAllImages: self];
return self;
}

- resetRuButtons:sender {int i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[ruButtons cellAt: i0: i1] setTitle: ""];
    }
  [self readWRule: ruleNumber];
  [self setAllImages: self];
return self;
}

- setAllImages:sender {int i0, i1;
  asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  {
    [[sqascru cellAt: i0: i1] setIntValue: binrule.two[i0][i1]];
    }
return self;
}

- setAllRules:sender {char ch[WNML]; int i, j, i0, i1;
   wru(ch);
   [ruleNumber setStringValue: ch];
   asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
    j=(KK*i0)+i1;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule.two[i0][i1]: j] setIntValue: YES];
    }
   wru(ch);
   [ruleNumber setStringValue: ch];
   [self nxasfreq];
   if      (istot()==1) {asctotot(); [self setTotRules: self];}
      else [totlRef setStringValue: " "];
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {int i, j; 
 for (i=0; i<KK; i++) for (j=0; j<16; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranRules:sender {
  granrule();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranPRules:sender {
  granprule();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* for 4-state automata, group the neighborhoods by twos and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument ascii rule  */
void wrru(c,ru) char *c, ru[KK][KK]; {
int  i, i0;
for (i0=0; i0<KK; i0++) {
  i= 4*(ru[i0][1]-'0')+(ru[i0][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-2*i0-2]=i;
  i= 4*(ru[i0][3]-'0')+(ru[i0][2]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-2*i0-3]=i;
  }
c[WNML-1]=0;
}

/* calculate (4,1) wru from an argument rule  */
void wtoru(c,ru) char *c, ru[KK][KK][KK]; {
int  i;
int  i0, i1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  i= 4*(ru[i0][i1][1]-'0')+(ru[i0][i1][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[KK*KK*2-2*(KK*i0+i1)-1]=i;
  i= 4*(ru[i0][i1][3]-'0')+(ru[i0][i1][2]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[KK*KK*2-2*(KK*i0+i1)-2]=i;
  }
c[KK*KK*2]=0;
}

/* calculate (4,3/2) wru from an argument rule  */
void wthru(c,ru) char *c, ru[KK][KK][KK][KK]; {
int  i;
int  i0, i1, i2;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++)
  {
  i= 4*(ru[i0][i1][i2][1]-'0')+(ru[i0][i1][i2][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[KK*KK*KK*2-2*(KK*(KK*i0+i1)+i2)-1]=i;
  i= 4*(ru[i0][i1][i2][3]-'0')+(ru[i0][i1][i2][2]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[KK*KK*KK*2-2*(KK*(KK*i0+i1)+i2)-2]=i;
  }
c[KK*KK*KK*2]=0;
}

/* calculate (4,5/2) wru from an argument rule  */
void wfhru(c,ru) char *c, ru[KK][KK][KK][KK][KK][KK]; {
int  i;
int  i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  i= 9*(ru[i0][i1][i2][i3][i4][2]-'0')
    +3*(ru[i0][i1][i2][i3][i4][1]-'0')
    +  (ru[i0][i1][i2][i3][i4][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[KK*(KK*(KK*(KK*(KK-i0)-i1)-i2)-i3)-i4-1]=i;
  }
c[KK*KK*KK*KK*KK]=0;
}

/* generate a random rule */
void granrule() {int i, i0, i1;
 for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  i=(random()&0xFF)%KK;
  ascrule[i0][i1]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++){
  if (i%7 == 0) j=random(); i++;
  if (auxrule[i0][i1]==0) ascrule[i0][i1]='0'+j%KK;
  j/=KK;
  }
}

/* since this method doesn't need a selected cell, it can be used  */
/* to initialize the text-slider pair according to the readings in */
/* either one of them.						   */

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

// - showProbability:sender 
// {int i, j; double pp, p[KK];
//   j=[sender selectedRow];
//   for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
//   for (pp=0.0, i=0; i<KK; i++) if (i!=j) pp+=p[i];
//   if (pp>0.001) {for (i=0; i<KK; i++) if (i!=j) p[i]*=(1.0-p[j])/pp;}
// 	else {for (i=0; i<KK; i++) if (i!=j) p[i]=(1.0-p[j])/((double)(KK-1));}
//   for (i=0; i<KK; i++) {
//     [[pSliders cellAt: i: 0] setDoubleValue: p[i]];
//     [[pWindows cellAt: i: 0] setDoubleValue: p[i]];
//     }
// return self;
// }

- randomLine:sender {double p[KK]; int i;
 for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

- uniformLine:sender {ranblin(0.25,0.25,0.25,0.25); return self;}

/* - - - - - - - -  R E C   L I N E   C O N F I G U R A T I O N  - - - - - */
 
- useRECLine:sender { 
  [RECPanel makeKeyAndOrderFront:sender];
  [RECValue setStringValue: "*"];
  return self;
}

- runRECLine:sender; {
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) {
     [RECValue setStringValue: "T"];
     [self setAllRules: self];
     [self setAllImages: self];
     }
  else
    [RECValue setStringValue: "F"];
  return self;
}

- eaterRule:sender {int ii, ij, ik, i0, i1;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++) {
  ii=(i0+1)%KK;
  ij=(i0+2)%KK;
  ik=(i0+3)%KK;
  ascrule[i0][i1]=i0+'0';
  switch ([eatingCell selectedRow]) {
    case 0: /* any neighbor eats */
      if (ii==i1) ascrule[i0][i1]=ii+'0';
      break;
    case 1: /* outers or inners in concert eat */
      if (ii==i1) ascrule[i0][i1]=ii+'0';
      if (ij==i1) ascrule[i0][i1]=ij+'0';
      break;
    case 2:  /* lefts or rights in concert eat */
      if (ii==i1) ascrule[i0][i1]=ii+'0';
      if (ij==i1) ascrule[i0][i1]=ij+'0';
      if (ik==i1) ascrule[i0][i1]=ik+'0';
      break;
    case 3: /* leftish or rightish in concert eat */
      break;
    case 4: /* either second neighbor eats */
      break;
    case 5: /* only leftish neighbors eat */
      break;
    case 6: /* any neighbor eats but nearest grab when equal */
      break;
    default: break;}
  }
return self;
}

- randomRule:sender {ranrul(); return self;}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[WNML];
//  printf("hello from setDemo \n");
 wru(ch);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  [self setAllImages: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {int i, j, p[KK], ru[KK][KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ru[i][j] = ascrule[p[i]][p[j]]-'0';
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) ascrule[i][j] = p[ru[i][j]]+'0';
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

- pmutValue: sender {int i, j, k, p[KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  p[3]=[pMut3 selectedCol];
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) {
    k = ascrule[i][j] - '0';
    ascrule[i][j] = p[k] + '0';
    }
  asctobin();
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - -   F R E D K I N   R E V E R S I B I L I T Y    - - - - - - */

- fredRev:sender {
int i0, i1, i2, i3;
  nutowo1([fredRule intValue]);
  if ([fredXor selectedRow]==0) {
    if ([fredDir selectedRow]==0) {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
        ascrule[2*i0+i1][2*i2+i3]='0'+((prule1[2*i1+i3]-'0')==i0?0:1)+2*i1;
      } else {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
      ascrule[2*i0+i1][2*i2+i3]='0'+2*((prule1[2*i0+i2]-'0')==i1?0:1)+i0;
      }
    } else {
    if ([fredDir selectedRow]==0) {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	ascrule[2*i0+i1][2*i2+i3]='0'+((prule1[2*i1+i3]-'0')==i2?0:1)+2*i3;
      } else {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	ascrule[2*i0+i1][2*i2+i3]='0'+2*((prule1[2*i0+i2]-'0')==i3?0:1)+i2;
      }
    }
  [self setAllRules:self];
  [self setAllImages:self];
return self;
}

- readFredMenu:sender {[self fr2h: [sender selectedRow]]; return self;}
- readFredCell:sender {[self fr2h: [sender intValue]]; return self;}

- fr2h:(int) i {
  [fredRule setIntValue: i];
  [fred2hRule selectCellAt: i: 0];
return self;
}

/* ar = char array for fredkin 4h rule */
/* pr = char array holding 2h rule     */
/* i  = xor, xnor switch	       */
/* j  = forward, reverse switch	       */

void fredrule(ar,pr,i,j) char ar[KK][KK], pr[4]; int i, j; {
int i0, i1, i2, i3;
  for (i0=0; i0<2; i0++)
  for (i1=0; i1<2; i1++)
  for (i2=0; i2<2; i2++)
  for (i3=0; i3<2; i3++)
    if (i==0) 
      if (j==0) ar[2*i0+i1][2*i2+i3]='0'+((pr[2*i1+i3]-'0')==i0?0:1)+2*i1;
      else      ar[2*i0+i1][2*i2+i3]='0'+2*((pr[2*i0+i2]-'0')==i1?0:1)+i0;
    else 
      if (j==0) ar[2*i0+i1][2*i2+i3]='0'+((pr[2*i1+i3]-'0')==i2?0:1)+2*i3;
      else      ar[2*i0+i1][2*i2+i3]='0'+2*((pr[2*i0+i2]-'0')==i3?0:1)+i2;
}

/* - - - - - - - - -    C A R T E S I A N   P R O D U C T    - - - - - - - - */

- prodRule:sender {int i0, i1, i2, i3;
	    nutowo1([[prodFact cellAt: 0: 0] intValue]);
	    nutowo2([[prodFact cellAt: 1: 0] intValue]);
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    ascrule[2*i0+i1][2*i2+i3]=
		'0'+2*(prule1[2*i0+i2]-'0')+(prule2[2*i1+i3]-'0');
  [self setAllRules:self];
  [self setAllImages: self];
return self;
}


/* - - - - - - - - - - - - -   G F ( 4 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
//    printf("hello from setMCoeff \n");
  s=[sender selectedRow];
    t=[sender tag];
    gf4rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
//    printf("hello from setVCoeff \n");
s=[sender selectedRow];
    t=[sender tag];
    gf4rule[t+8]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
//    printf("hello from setSCoeff \n");
s=[sender selectedRow];
    gf4rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF4Rule:sender {
//   int i; for (i=0; i<8; i++) printf("%1d ",gf4rule[i]); printf("\n");
//      printf("hello from enterGF4Rule \n");
  gftoasc();
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - -    R E V E R S I B L E    R U L E S   - - - - - - - - - */

char revlist[RBLNUM][WNML] = {
"FFAA5500",
"FFAA0550",
"FFAA4510",
"FFA91640",
"FF229548",
"FF2A9540",
"FEAB0550",
"FAAF0550",
"F5A0F5A0",
"F5A0F528",
"F0A5F5A0"
};

/* --------------------- B R O W S E R   D E L E G A T E ------------------- */

- (int)browser: sender fillMatrix: matrix inColumn: (int)col {
char ch[48];
int  i, j, k, l, m;
  if (col==0) {
    for (i=0; i<RBLNUM; i++) {
      [matrix addRow];
      [[matrix cellAt: i: 0] setLeaf: YES];
      [[matrix cellAt: i: 0] setLoaded: YES];
      [[matrix cellAt: i: 0] setEnabled: YES];
      sprintf(ch,"%3d: %s",i+1,revlist[i]);
      [[matrix cellAt: i: 0] setStringValue: ch];
      }
    return RBLNUM;
    }
  else return 0;
}

/* to distract the single click in a browser double click */
- nhul: sender {int i;
  i=[[sender matrixInColumn: 0] selectedRow];
  [ruleNumber setStringValue: revlist[i]];
  [self readWRule: ruleNumber];
 return self;}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [self setAllImages: self];
    [toWindow setDocEdited:NO];
return self;
}

- readTRule:sender
  {char  *c; int i, j, l, m;
     c=[sender stringValue];
     l=strlen(c); m=YES;
     if(l>TS) {[toRuleNumber setStringValue: "too long"]; return self;}
     for (j=0; j<TS; j++) ttrule[j]='0';
     for (j=0; j<l;  j++) {
       i=c[j];
       if ( i<'0' || i>'3' ) {c[j]='*'; m=NO;}
       }
     if (m) for (j=0; j<l; j++) ttrule[j]=c[j];
       else {[sender display]; return self;}
     totoasc();
     [self setTotRules: self];
     return self;
   }

/* copy ttrule */
void wtrru(c, ru) char *c, ru[TS]; {int  i;
  for (i=0; i<TS; i++) c[i]=ru[i];
  c[TS]=0;
}

- setTotRule:sender {char ch[WNML];
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toWindow setDocEdited:YES];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  if (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
  else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- ranTRule:sender {char ch[TS+1]; int i, j, k;
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) [[toascru cellAt: i: j] setIntValue: NO];
    k=random()%KK;
    ttrule[j]=k+'0';
    [[toascru cellAt: k: j] setIntValue: YES];
    }
  wtrru(ch,ttrule);
  [toRuleNumber setStringValue: ch];
  [toRuleNumber selectText: self];
  [toWindow setDocEdited:YES];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i;
for (i=0; i<TS; i++)
   if (tarule[i]==0) ttrule[i]='0'+random()%KK;
}

/* generate a random totalistic rule */
void grantotrule() {int i; for (i=0; i<TS; i++) ttrule[i]='0'+random()%KK;}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophobic:sender {int i, j;
  for (i=0; i<KK; i++) ascrule[i][i]=i+'0';
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) 
    switch ([[clanMatrix cellAt: i: j] title][0]) {
    case '0': ascrule[i][j]=i+'0'; ascrule[j][i]=i+'0'; break;
    case '1': ascrule[i][j]=j+'0'; ascrule[j][i]=i+'0'; break;
    case '2': ascrule[i][j]=i+'0'; ascrule[j][i]=j+'0'; break;
    case '3': ascrule[i][j]=j+'0'; ascrule[j][i]=j+'0'; break;
    default: break;}
  [self setAllRules: self];
  [self setAllImages: self];
return self;
}

- enterPair:sender {char c[2]; 
  c[0] = [clan2h selectedRow]+'0'; c[1]=0;
  [[sender selectedCell] setTitle: c];
return self;
}

- randphobic:sender {char c[2]; int i, j;
  for (i=0; i<KK-1; i++) for (j=i+1; j<KK; j++) {
    c[0] = (random()%4)+'0'; c[1]=0;
    [[clanMatrix cellAt: i: j] setTitle: c];
    }
return self;
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {
char c[2];
int  k, i0, i1;
  k=[sender tag];
  i1=k%KK; k/=KK;
  i0=k%KK;
  switch ([designRef selectedRow]) {
      case 0:  c[0]=i0+'0'; break;		/* copy left cell   */
      case 1:  c[0]=i1+'0'; break;		/* copy right cell  */
      case 2:  c[0]='0'; break;			/* constant value 0 */
      case 3:  c[0]='1'; break;			/* constant value 1 */
      case 4:  c[0]='2'; break;			/* constant value 2 */
      case 5:  c[0]='3'; break;			/* constant value 3 */
      default: c[0]=' '; break;}
  dsgnrule[i0][i1]=c[0];
  c[1]=0;
  [sender setTitle: c];
return self;
}

- clearDesign:sender {
  [dsgn00 setTitle: " "];
  [dsgn01 setTitle: " "];
  [dsgn02 setTitle: " "];
  [dsgn03 setTitle: " "];
  [dsgn10 setTitle: " "];
  [dsgn11 setTitle: " "];
  [dsgn12 setTitle: " "];
  [dsgn13 setTitle: " "];
  [dsgn20 setTitle: " "];
  [dsgn21 setTitle: " "];
  [dsgn22 setTitle: " "];
  [dsgn23 setTitle: " "];
  [dsgn30 setTitle: " "];
  [dsgn31 setTitle: " "];
  [dsgn32 setTitle: " "];
  [dsgn33 setTitle: " "];
return self;
}

- copyToDesign:sender {
char c[2];
int  i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
	dsgnrule[i0][i1]=ascrule[i0][i1];
  c[1]=0;
  c[0]=ascrule[0][0]; [dsgn00 setTitle: c];
  c[0]=ascrule[0][1]; [dsgn01 setTitle: c];
  c[0]=ascrule[0][2]; [dsgn02 setTitle: c];
  c[0]=ascrule[0][3]; [dsgn03 setTitle: c];
  c[0]=ascrule[1][0]; [dsgn10 setTitle: c];
  c[0]=ascrule[1][1]; [dsgn11 setTitle: c];
  c[0]=ascrule[1][2]; [dsgn12 setTitle: c];
  c[0]=ascrule[1][3]; [dsgn13 setTitle: c];
  c[0]=ascrule[2][0]; [dsgn20 setTitle: c];
  c[0]=ascrule[2][1]; [dsgn21 setTitle: c];
  c[0]=ascrule[2][2]; [dsgn22 setTitle: c];
  c[0]=ascrule[2][3]; [dsgn23 setTitle: c];
  c[0]=ascrule[3][0]; [dsgn30 setTitle: c];
  c[0]=ascrule[3][1]; [dsgn31 setTitle: c];
  c[0]=ascrule[3][2]; [dsgn32 setTitle: c];
  c[0]=ascrule[3][3]; [dsgn33 setTitle: c];
return self;
}

- enterDesign:sender {
int i0, i1;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
	ascrule[i0][i1]=dsgnrule[i0][i1];;
//	auxrule[i0][i1]=(k<KK?1:0);
	}
  [self setAllRules: self];
  [self setAllImages: self];

return self;
}

int permut(k,n) int k, n; {		/*   this function is added         */
 switch (n) {
    case 0: break;
    case 1: k=(k+1)%KK; break;
    case 2: k=(KK+k-1)%KK; break;
    case 3: if (k==1) k=2; else if (k==2) k=1; break;
    case 4: if (k==2) k=0; else if (k==0) k=2; break;
    case 5: if (k==0) k=1; else if (k==1) k=0; break;
    default: break;}
  return k;
}

/* - - - - - - - - - - - -  D A T A   D I S P L A Y  - - - - - - - - - - - - */

- symMetr:sender {
char ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, l;
  l=allperm(wnum,ii,ascrule);
  [self showDataText: "Symmetry\n Class:\n\n"];
  for (i=0; i<RSYM; i++) {
    [self showDataText: wnum[i]];
    [self showDataText: "\n"];
    }
  [dataText setSel: 9*l+18: 9*(l+1)+18];
return self;
}

- perMute:sender {
char    c[12], d[12];
int     i, k;
birular ru;
  wrru(d,ascrule);
  asctobin();
  ru=binrule;
  [self showDataText: "Permuted\n Values:\n\n"];
  for (i=0, k=0; i<24; i++) {
    ptedbrul(&binrule,&ru,i);
    bintoasc();
    wrru(c,ascrule);
    if (strcmp(c,d)<0) {strcpy(d,c); k=i;}
    [self showDataText: c];
    [self showDataText: "\n"];
    }
  [dataText setSel: 9*k+19: 9*(k+1)+19];
return self;
}

- showDataText:(char *)ch {int tl;
  tl=[dataText textLength];
  [dataText setSel: tl: tl];
  [dataText replaceSel:  ch];
  [dataText scrollSelToVisible];
  [dataText display];
return self;
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<24; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, k, i0, i1, i2;
int    stat[KK], statp[KK][KK];		/* statics counts   */
int    shif[RR];			/* shifts counts    */ 
int    xe;				/* xenofhobic count */
double staf[KK], stapf[KK][KK],t, pp, qq;
xe=0;
pp=1.0/((double)(DS));
qq=pp/((double)KK);
for (i=0; i<RR; i++) shif[i]=0;
for (i=0; i<KK; i++) {
                      stat[i]=0; 
			for (j=0; j<KK; j++) statp[i][j]=0;
                      }
for (i0=0; i0<KK; i0++)
     for (i1=0; i1<KK; i1++) {
          j=ascrule[i0][i1]-'0';
          stat[j]++;
          if (j==i0) shif[0]++;  		  
          if (j==i1) shif[1]++;   			  
          if (j==i0 || j==i1 ) xe++;
                for (i2=0; i2<KK; i2++) {
                     k=ascrule[i1][i2]-'0';
                     statp[j][k]++;
                    }
         }

for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
for (i=0; i<RR; i++) 
      [[statIndx cellAt: i: 0] setDoubleValue: ((double)shif[i])*pp];

for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
[statLamb setDoubleValue: 1.0-staf[0]];
[statEntro setDoubleValue: -t/log((double)KK)];
for (i=0, t=0.0; i<KK; i++) 
    for (j=0; j<KK; j++){
         stapf[i][j]=((double) statp[i][j])*qq;
         [[statPairs cellAt: i: j] setDoubleValue: stapf[i][j]];
         t+=stapf[i][j]*log(stapf[i][j]);
        }
[statPEntro  setDoubleValue: -t/log((double)(KK*KK))];
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}


/* ------------  A R I T H M E T I C   C O M B I N A T I O N ------------ */

- arithmCombs: sender
{
birular aza, bzb, czc;
  printf("estoy en arithCombs\n");
  [self readWRule: [twoRules cellAt: 0: 0]];
  asctobin();
  bincopy(&aza, &binrule); 
  printf("salio de bincopy\n");
  printf("imprime aza\n");
  binprint(&aza);
  [self readWRule: [twoRules cellAt: 1: 0]];
  asctobin();
  bincopy(&bzb, &binrule);
  printf("imprime bza\n");
  binprint(&bzb);
  switch ([sender selectedRow]) {
     case 0: binsum(&czc, &aza, &bzb); break;
     case 1: binprod(&czc, &aza, &bzb); break;
     default: printf("arithCombs\n"); return self;}
  printf("imprime czc\n");
  binprint(&czc);
  bincopy(&binrule,&czc);
  bintoasc();
  [self setAllRules: self];
  [self setAllImages: self];
  binprint(&binrule);
return self;
}

- initTwoRules:sender
 {char c[12];
   granrule();
   wru(c);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: c];
  return self;
 }

/* copy one binary rule from another */
void bincopy(rz,rx)  birular *rz, *rx;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=rx->one[i];}

/* fill ascrule from binrule */
void bintoasc()
{int i0, i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    ascrule[i0][i1]=binrule.two[i0][i1]+'0';
}

/* sum two binary rules mod KK */
void binsum(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++)  rz->one[i]=(rx->one[i]+ry->one[i])%KK;}


/* multiply two binary rules mod KK */
void binprod(rz, rx, ry) birular *rz, *rx, *ry;
{int i; for(i=0; i<KK*KK; i++) rz->one[i]=(rx->one[i]*ry->one[i])%KK;}

/* print a binary rule (all 16 numbers) */
void binprint(rz) birular *rz; {int i;
for(i=0; i<KK*KK; i++) printf("%c",rz->one[i]+'0');
printf("\n");
}

@end

/* end RulePanel.m */
