
/* nxlcau4h.h			*/
/* header for lcau4h.c		*/
/* 5 October 1989		*/

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define YELREGR     2  /* color quad for alternative screen	*/
# define TRR	    16  /* row showing totalistic rule number	*/
# define TRC	    56  /* column for totalistic rule number	*/
# define XRR	    12  /* row displaying totalistic rule	*/
# define XRC	    56  /* column for totalistic rule		*/
# define AL        320  /* array length (screen width)		*/
# define SL	    40	/* short array length			*/
# define TS	     7	/* distinct sums w/totalistic rule	*/
# define DS	    16  /* (number of distinct neighborhoods)	*/
# define KK	     4  /* number of states per cell	        */
# define RR	     2  /* length of neighborhood = 2r+1	*/ 
# define DN         KK	/* number of distinct nodes		*/
# define PDN        16	/* nodes in pair diagram = KK^4r	*/
# define TDN	    64  /* nodes in pair diagram = KK^6r	*/
# define SDN        16	/* nodes in subset diagram = 2^(KK^2r)	*/
# define BD	    20  /* maximum degree of b.p.		*/
# define SS ((RR-1)*(KK-1)+1) 	/* distinct sums w/stotalistic rule	*/

# define RBLNUM      11		/* number of reversible clusters	*/
# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK)
# define HH	60		/* points in histogram */
# define CLEN 		300	/* buffer length for REC sourse */
# define PLEN		900	/* buffer length for REC object */ 
# define NY 		24
# define NRR	        11	/* number of reversible rule classes	*/
# define XLEN 		128
  
# define RSYM		48	/* number of rule symmetries = 2*k!	*/
# define WNML	         9	/* arry size to hold hex wolfram number */

# define CCY          6		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/

# define XDB	   1024		/* max dimension de Bruijn diagram	*/

typedef union birular {
	int one[KK*KK];
	int two[KK][KK];
	} birular;
typedef union parneih {
	int one[K2];
	int two[KK][KK];
	} parneih;
typedef union twoparn {
	int one[K4];
	int two[K2][K2];
	int four[KK][KK][KK][KK];
	} twoparn;
typedef union thrparn {
	int one[K6];
	int two[K3][K3]; 
	int three[K2][K2][K2];
	int six[KK][KK][KK][KK][KK][KK];
	} thrparn;

/* end nxlcau4h.h */
